#define APPNAME  "test - colorrect"
#define APPTITLE "test - colorrect"

#define _RELEASE_(p) { if(p) { (p)->Release(); (p)=NULL; };}
#define _DELETE_(p)  { if(p) { delete (p);     (p)=NULL; };}

#include <windows.h>
#include <time.h>

#include <d3d8.h>
#include <d3dx8.h>
#pragma comment (lib, "dxguid.lib")
#pragma comment (lib, "d3d8.lib")
#pragma comment (lib, "d3dx8.lib")


//ؽ ü Ÿ 
struct CUSTOMVERTEX { 
	FLOAT x, y, z; 
	DWORD   color;
};
#define D3DFVF_CUSTOMVERTEX ( D3DFVF_XYZ | D3DFVF_DIFFUSE)

bool g_bIsFullScreen = false;	    // is our app Full screen or not
int g_iScreenX = 640, g_iScreenY = 480;	// use this if 'not'
D3DDISPLAYMODE  g_d3ddm;


BOOL	g_bActive = TRUE;
HWND	g_hWnd = NULL;

LPDIRECT3D8             g_d3d        = NULL; // our main d3d8 interface
LPDIRECT3DDEVICE8       g_d3d_Device = NULL; // our d3d8 device
LPDIRECT3DVERTEXBUFFER8 g_VertexBuffer = NULL; // our VertexBuffer
D3DPRESENT_PARAMETERS	g_d3dpp; 


LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);


bool WindowInit(HINSTANCE hInst, int nCmdShow);
bool AppInit(HINSTANCE hInst, int nCmdShow);
HRESULT InitD3D(HWND hWnd);
void SetupCamera();
bool RenderInit();
void DestroyDirect3D8();
HRESULT ResetDeviceObjects();
HRESULT RenderLoop();
HRESULT Render3D();
void	DestroyDirect3D8();


//-----------------------------------------------------------------------------
LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_ACTIVATE:
		g_bActive = LOWORD(wParam);
		return 0;
		break;

	case WM_KEYDOWN:
		if (wParam == VK_ESCAPE)
		{
			DestroyDirect3D8();
			DestroyWindow(hWnd);
			PostQuitMessage(0);
		}
		break;

	case WM_CLOSE:          
		DestroyDirect3D8();
        DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	case WM_SYSCOMMAND:
		// Prevent moving/sizing and power loss in fullscreen mode
		switch( wParam )
		{
			case SC_MOVE:
			case SC_SIZE:
			case SC_MAXIMIZE:
			case SC_KEYMENU:
			case SC_MONITORPOWER:
				if( g_bIsFullScreen)
					return 1;
				break;
		}
		break;

    case WM_NCHITTEST:
       // Prevent the user from selecting the menu in fullscreen mode
        if(g_bIsFullScreen)
              return HTCLIENT;
        break;
/*  콺 Ŀ ʿ   Ѵ
	case WM_SETCURSOR:
		SetCursor (NULL);
		return 0;
		break; 
*/
	};
	return DefWindowProc(hWnd, message, wParam, lParam);
}
//-----------------------------------------------------------------------------
bool WindowInit(HINSTANCE hInst, int nCmdShow)
{
	WNDCLASS		    wcl;
		
	wcl.hInstance		= hInst;
	wcl.lpszClassName	= APPNAME;
	wcl.lpfnWndProc		= WindowProc;
	wcl.style			= 0;

	wcl.hIcon			= LoadIcon (NULL, IDC_ICON);
	wcl.hCursor			= LoadCursor (NULL, IDC_ARROW);
	wcl.lpszMenuName	= NULL;

	wcl.cbClsExtra		= 0;
	wcl.cbWndExtra		= 0;
	wcl.hbrBackground	= (HBRUSH) GetStockObject (BLACK_BRUSH);

	RegisterClass (&wcl);

	if(g_bIsFullScreen)
	{
		g_hWnd = CreateWindowEx (
			NULL,
			APPNAME,
			APPTITLE,
			WS_POPUP|WS_SYSMENU|WS_VISIBLE, 
			0, 0, 
			g_d3ddm.Width,
			g_d3ddm.Height,
			NULL,
			NULL,
			hInst,
			NULL);
	}
	else
	{
		int sx = GetSystemMetrics (SM_CXSCREEN);
		int sy = GetSystemMetrics (SM_CYSCREEN);

		g_hWnd = CreateWindowEx (
			NULL,
			APPNAME,
			APPTITLE,
			WS_OVERLAPPED | WS_SYSMENU,
			sx/2 - g_iScreenX/2, sy/2 - g_iScreenY/2,
			g_iScreenX,
			g_iScreenY,
			NULL,
			NULL,
			hInst,
			NULL);
	};

	if(!g_hWnd) 
		return false;

	return true;
}
//-----------------------------------------------------------------------------
bool AppInit(HINSTANCE hInst, int nCmdShow)
{
	srand (time(0)); // randomize timer

	if(!WindowInit (hInst, nCmdShow)) 
		return false;

	ShowWindow (g_hWnd, nCmdShow);
	UpdateWindow (g_hWnd);
    
	return true;
}
//-----------------------------------------------------------------------------
HRESULT InitD3D(HWND hWnd)
{
	ZeroMemory (&g_d3dpp, sizeof(g_d3dpp));

    if( NULL == ( g_d3d = Direct3DCreate8( D3D_SDK_VERSION ) ) )
        return E_FAIL;

	if(g_bIsFullScreen)
	{
		g_d3dpp.BackBufferWidth = g_d3ddm.Width;
		g_d3dpp.BackBufferHeight = g_d3ddm.Height;
		g_d3dpp.BackBufferCount = 1;
		g_d3dpp.FullScreen_RefreshRateInHz = g_d3ddm.RefreshRate; //D3DPRESENT_RATE_DEFAULT
		g_d3dpp.FullScreen_PresentationInterval = D3DPRESENT_INTERVAL_ONE;
	}
	else
	{
		if( FAILED( g_d3d->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &g_d3ddm)))
			return E_FAIL;
	}

    g_d3dpp.Windowed = !g_bIsFullScreen;
    g_d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
    g_d3dpp.BackBufferFormat = g_d3ddm.Format;

	g_d3dpp.EnableAutoDepthStencil	= TRUE; 
	g_d3dpp.AutoDepthStencilFormat	= D3DFMT_D16;

    if(FAILED(g_d3d->CreateDevice (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, 
								   D3DCREATE_SOFTWARE_VERTEXPROCESSING, 
								   &g_d3dpp, &g_d3d_Device)))
	{
		g_d3dpp.AutoDepthStencilFormat	= D3DFMT_D32;
		if(FAILED(g_d3d->CreateDevice (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, 
								   D3DCREATE_SOFTWARE_VERTEXPROCESSING, 
								   &g_d3dpp, &g_d3d_Device)))
			return E_FAIL;
	}

	g_d3d_Device->SetRenderState( D3DRS_ZENABLE, TRUE );
	g_d3d_Device->SetRenderState( D3DRS_AMBIENT, 0xffffffff );
	g_d3d_Device->SetRenderState( D3DRS_LIGHTING, FALSE );
	return S_OK;
}
//-----------------------------------------------------------------------------
void SetupCamera()
{
    D3DXMATRIX   matProj;
	D3DXMATRIX	 matCameraView;
	D3DXVECTOR3  cameraTarget;
    D3DXVECTOR3  cameraPos;

	// Set where camera is viewing from
	cameraPos.x = 0.0f;
	cameraPos.y = 0.0f;
	cameraPos.z = -10.0f;
	// Set what camera is looking at
	cameraTarget.x = 0.0f;
	cameraTarget.y = 0.0f;
	cameraTarget.z = 0.0f;

	// Setup Camera View
	D3DXMatrixLookAtLH( &matCameraView, 
						&cameraPos, 
						&cameraTarget, 
						&D3DXVECTOR3( 0.0f, 1.0f, 0.0f ) );
	// Tell the device to use the camera view for the viewport
	g_d3d_Device->SetTransform( D3DTS_VIEW, &matCameraView );

	// Setup Projection 
	D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, 1.0f, 1.0f, 100.0f );
	// Tell the device to use the above matrix for projection
	g_d3d_Device->SetTransform( D3DTS_PROJECTION, &matProj );
}
//-----------------------------------------------------------------------------
bool RenderInit()
{
	CUSTOMVERTEX vertex[4];
	void	*lpVertices;
	float	fSizeX = 5.0f;
	float	fSizeY = 5.0f;
	
	// Create the geometry
	vertex[0].x = -fSizeX/2;
	vertex[0].y = fSizeY/2;
	vertex[0].z = 0.0f;
	vertex[0].color = 0xff;

	vertex[1].x = fSizeX/2;
	vertex[1].y = fSizeY/2;
	vertex[1].z = 0.0f;
	vertex[1].color = 0xff;
	
	vertex[2].x = -fSizeX/2;
	vertex[2].y = -fSizeY/2;
	vertex[2].z = 0.0f;
	vertex[2].color = 0xff;
	
	vertex[3].x = fSizeX/2;
	vertex[3].y = -fSizeY/2;
	vertex[3].z = 0.0f;
	vertex[3].color = 0xff;
	
	// Create the vertex buffer
	if(FAILED(g_d3d_Device->CreateVertexBuffer(4*sizeof(CUSTOMVERTEX), 
		                   0, D3DFVF_CUSTOMVERTEX, D3DPOOL_DEFAULT, &g_VertexBuffer))) 
	{
		return false;
	}
	// Lock the buffer
	if(FAILED(g_VertexBuffer->Lock(0, sizeof(vertex), (BYTE**)&lpVertices, 0))) 
	{
		return false;
	}
	// Copy the g_Vertices information into the buffer
	memcpy(lpVertices, vertex, sizeof(vertex));
	// Unlock the buffer
	g_VertexBuffer->Unlock();
	return true;
}
//-----------------------------------------------------------------------------
void DestroyDirect3D8()
{
	_RELEASE_ (g_VertexBuffer);
	_RELEASE_ (g_d3d_Device);
	_RELEASE_ (g_d3d);
}
//-----------------------------------------------------------------------------
HRESULT ResetDeviceObjects()
{
	HRESULT hr;

    // Release all vidmem objects
    //if( FAILED( hr = InvalidateDeviceObjects() ) )
    //    return hr;

	// Reset the device
	if( FAILED( hr = g_d3d_Device->Reset( &g_d3dpp ) ) )
		return hr;

	return S_OK;
}
//-----------------------------------------------------------------------------
HRESULT RenderLoop()
{
    HRESULT hr;

    // Test the cooperative level to see if it's okay to render
    if( FAILED( hr = g_d3d_Device->TestCooperativeLevel() ) )
    {
        // If the device was lost, do not render until we get it back
        if( D3DERR_DEVICELOST == hr )
            return S_OK;

        // Check if the device needs to be resized.
        if( D3DERR_DEVICENOTRESET == hr )
        {
            // If we are windowed, read the desktop mode and use the same format for
            // the back buffer
            if( !g_bIsFullScreen )
            {
				g_d3d->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &g_d3ddm);
                g_d3dpp.BackBufferFormat = g_d3ddm.Format;
            }

            if( FAILED( hr = ResetDeviceObjects() ) )
                return hr;
        }
        return hr;
    }

    // Render the scene as normal
    if( FAILED( hr = Render3D() ) )
        return hr;

	return S_OK;
}
//-----------------------------------------------------------------------------
HRESULT Render3D ()
{
	HRESULT hr;

	//D3DXMATRIX	matTranslation;

	// Clear the scene
	g_d3d_Device->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,
		                                D3DCOLOR_XRGB(150,150,255), 1.0f, 0 );
	g_d3d_Device->BeginScene();

	//D3DXMatrixIdentity( &matTranslation );
	//g_d3d_Device->SetTransform(D3DTS_WORLD, &matTranslation);
	g_d3d_Device->SetStreamSource(0, g_VertexBuffer, sizeof(CUSTOMVERTEX));
	g_d3d_Device->SetVertexShader(D3DFVF_CUSTOMVERTEX);
	g_d3d_Device->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);

	g_d3d_Device->EndScene();
	// Output the scene
	hr = g_d3d_Device->Present( NULL, NULL, NULL, NULL );
	return hr;
}
//-----------------------------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;
	if(!AppInit(hInst, nCmdShow)) 
		return -1;
	if(InitD3D(g_hWnd)!= S_OK )
		return -1;
	
	SetupCamera();

	if(!RenderInit())
		return -1;

	BOOL bGotMsg;

	msg.message = WM_NULL;
	PeekMessage( &msg, NULL, 0U, 0U, PM_NOREMOVE );
    while( WM_QUIT != msg.message  )
    {
        // Use PeekMessage() if the app is active, so we can use idle time to
        // render the scene. Else, use GetMessage() to avoid eating CPU time.
        if( g_bActive )
            bGotMsg = PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE );
        else
            bGotMsg = GetMessage( &msg, NULL, 0U, 0U );

        if( bGotMsg )
        {
            // Translate and dispatch the message
            //if( 0 == TranslateAccelerator( g_hWnd, hAccel, &msg ) )
            {
                TranslateMessage( &msg );
                DispatchMessage( &msg );
            }
        }
        else
        {
            // Render a frame during idle time (no messages are waiting)
            if( g_bActive )//&& m_bReady )
            {
                if( FAILED( RenderLoop()))
                    SendMessage( g_hWnd, WM_CLOSE, 0, 0 );
            }
        }
    }

	UnregisterClass( APPNAME, hInst);
	return 0;
}
//-----------------------------------------------------------------------------
